/*
 * complex.h
 *
 *  Created on: Sep 21, 2015
 *      Author: richer
 */

#ifndef COMPLEX_H_
#define COMPLEX_H_

#include "data_type.h"

struct aComplex {
	REAL r;
	REAL i;

	aComplex(REAL a, REAL b) : r(a), i(b) {

	}

	REAL norm() {
		return r * r + i * i;
	}

	aComplex operator*(const aComplex& a) {
		return aComplex(r*a.r - i*a.i, i*a.r + r*a.i);
	}

	aComplex operator+(const aComplex& a) {
		return aComplex(r+a.r, i+a.i);
	}
	
};

typedef struct aComplex aComplex;

#endif /* COMPLEX_H_ */
