#ifndef CPU_TIMER_H_
#define CPU_TIMER_H_

#include <stdint.h>
#include <iostream>
#include <math.h>
#include <chrono>
#include <iomanip>

typedef uint64_t long_integer;

using namespace std;

/* ==================================================================
 * Class used to mesure time elapsed of a treatment
 *
 */
class CPUTimer {
public:
	
	typedef std::chrono::time_point<std::chrono::steady_clock> Clocks;

	typedef std::chrono::nanoseconds  nano_sec;
	typedef std::chrono::microseconds micro_sec;
	typedef std::chrono::milliseconds milli_sec;

	// start event
	Clocks _event_start;
	// stop event
	Clocks _event_stop;

	CPUTimer();

	void start();

	void stop();

	long_integer ns();

	long_integer us();

	long_integer ms();

	long_integer s();

	long_integer s_elapsed();
	
	long_integer ms_elapsed();

	ostream& print( ostream& out );

	friend ostream& operator<<( ostream& out, CPUTimer& obj ) {
		return obj.print(out);
	}

private:

	Clocks get_clocks();
	
};



#endif /* CPU_TIMER_H_ */
