#include "tiny_lib.h"

string Terminal::b_underline = "\33[4m";
string Terminal::e_underline = "\033[0m";
string Terminal::b_bold = "\033[1m";
string Terminal::e_bold = "\033[0m";

string Terminal::bold( string s ) {

	string r = b_bold + s + e_bold;
	return r;
	
}


string Terminal::underline( string s ) {

	string r = b_underline + s + e_underline;
	return r;
	
}


	
/* ==================================================================
 * SUBPROGRAM
 *
 *  void help_clopt_wa( char _shortf, string _longf, 
 *		string arg, string text );
 *
 * WHAT
 * 
 *  Display help about Command Line OPTion With Argument
 *
 * PARAMETERS
 *
 *	@paramdef(char, _shortf) : command line option in short format
 *	@paramdef(string, _longf) : command line option in long format
 *	@paramdef(string, arg) : argument of the option
 *	@paramdef(string, text) : description
 *
 * ==================================================================
 */
void help_clopt_wa( char _shortf, string _longf, string arg, string text ) {
		
	cout << "\t-" << _shortf << " " << Terminal::underline( arg );
	cout << " --" << _longf << "=" << Terminal::underline( arg ) << "\n\t\t";
	cout << text << "\n\n";
}

/* ==================================================================
 * SUBPROGRAM
 *
 *  void help_clopt_na( char _shortf, string _longf, 
 *		string arg, string text );
 *
 * WHAT
 * 
 *  Display help about Command Line OPTion with No Argument
 *
 * PARAMETERS
 *
 *	@paramdef(char, _shortf) : command line option in short format
 *	@paramdef(string, _longf) : command line option in long format
 *	@paramdef(string, text) : description
 *
 * ==================================================================
 */
void help_clopt_na( char _shortf, string _longf, string text ) {
	
	cout << "\t-" << _shortf << " ";
	cout << " --" << _longf << "\n\t\t";
	cout << text << "\n\n";
}

